function [check] = isPositive(P,x1,x2)
% Returns 1 if univariate polynomial P has no
% no real roots in the interval [x1,x2], and
% is positive at the mid-point.
%
% This is a sufficient condition for P to
% be positive on the interval [x1,x2].
p = sym2poly(P);
r = roots(p);
check = polyval(p,(x2+x1)/2)>0 & all( abs(imag(r))>1e-12 | (r <= x1) |(r >= x2) );

