% Assumes you have already run largemu and smallMu_step1, and just implements the diff to run
% step 2

deltamax = 1/8/n;

B0 = 2 * delta * h;
B3 = - ( (1-2/n)*a2 + 1/n*(a1+a2 -2*alpha/n*b + alpha*alpha/n/n*c )-(1-deltamax)*a2);
B4 = - n * ( (1-2/n)*(a1-2*alpha/n*b+alpha*alpha/n/n*c) - (1-deltamax)*a1 ) + B3;
B5 = 2* (  ( delta-1/n)*b - alpha/n*(1-1/n)*c);
B7max = 2 * ( a1 - 2*alpha/n*b + alpha*alpha/n/n*c ) + 2 * ( - h*(1-deltamax)*d );
B9 = c * delta;

C0_B4_mu = - B0/2*B4 + B9*B4/mu +n/4*B5*B5/mu;
C13_B3B4 = B0*B3*B4+B1*B3*B4 + n/4*B6*B6*B4+n/2*B5*(B6+B7)*B3+n*B8*B3*B4 + B3*B4*C3;
C2_B3B4 = -B2*B3*B4-n/4*B6*B6*B4 + n/4*(B6+B7)*(B6+B7max)*B3;

% Check expressions that are affine in y
for P = [n*a1+a2+n*mu*d*d, ... % Constraint 5
        (1/2*(2*h-gamma) + c)*(n*a1+a2+n*mu*d*d) - (d+b)*(d+b)*n,... % Constraint 6
        -C2_B3B4] % Constraint 7
    isPositive(subs( P , y , 0 ),0,1/2);
    isPositive(subs( P , y , 1 ),0,1/2);
end

% Check second-order expressions in y
for P = [-C13_B3B4, ... % Constraint 8
        -(C0_B4_mu*B3+C13_B3B4+C2_B3B4*mu )] % Constraint 9
    temp = simplify(P);
    param0 =  subs( temp , y , 0 );
    param1 =  subs( diff(temp,y), y , 0 );
    param2 =  subs( diff(temp,y,2), y , 0 )/2;
    
    isPositive(param2,0,1/5) % check that second order is positive
    isPositive(-param1,0,1/5) % check that first order is negative
    isPositive(-param1 - 2*param2,0,1/5) % gradient at 1 is negative
    isPositive(subs( temp , y , 1 ),0,1/5) % simply check at 1
end
